<template>
  <v-container fluid class="px-2" fill-height>
    <v-layout column class="lane" fill-height> 
        <div xs12 class="mb-2">
           <div class="headline mb-0 pb-0 pt-2" :id="id + '_title'" :style="'height: 2em; font-weight: bolder; color: ' + titleColor">
                <slot name="title">{{title}}</slot>
           </div>
           {{itemCount}}
        </div>
       
        <draggable v-model="draggables" :options="{ group: 'default' }" style="min-height: 120px">
            <ApplicationCard  
                 v-for="(item, index) in showItems" 
                 :key="item.id" 
                 :showInterviewBadge="true"
                 :item="item" 
                 :initialState="index > 2"
                 @success="$emit('success')" 
                 @error="$emit('error')"
                 @archive="setItemStatus(item, 'CLOSED')" 
                 @remove="removeItem(item, index)"
                 class="ma-2" />
        </draggable>
        
         <div v-if="totalItems > items.length" class="subheading pt-2 pb-2" style="text-transform: uppercase"> 
              <router-link :to="{ path: '/secure/search', query: {status: id, scope: scope} }" class="unstyled-link">
              {{ $i18n.t('board.viewAll') }} 
              </router-link>
        </div>
        
     </v-layout>
</v-container>
</template>

<script>
import Draggable from 'vuedraggable';
import ApplicationCard from './ApplicationCard';
export default {
  name: 'StatusLane',
  props: [ 'title', 'id', 'items', 'titleColor', 'scope', 'maxLaneItems', 'total'],
  components: {
    ApplicationCard,
    draggable: Draggable
  },
  methods: {
    async removeItem(item, index) {
      this.items.splice(index, 1)
      try {
        this.$emit('collectionChange', item, this.id, null)
        await this.$api.deleteApplication(item)
      }
      catch ( e )  {
        this.$logger.error(e.message)
        this.$emit('error')
        this.items.push(index, 0, item)
      }
    },
    async setItemStatus(item, status) {
        const previousStatus = item.status
        this.$emit("collectionChange", item, previousStatus, status)
        try {
          Object.assign(item, { status });
          const result = await this.$api.patchApplication(item.id, { status })
          Object.assign(item, result);
        }
        catch ( e ) {
          this.$logger.error(e.message);
          this.$emit('error')
          Object.assign(item, { previousStatus });
          this.$emit("collectionChange", item, status, previousStatus)
        }
    }
  },
  computed: {
    totalItems() { 
       return this.total 
    },
    showItems() {
       return this.items;
    },
    itemCount() {
      const elem = this.id.toLowerCase() == 'saved' ? 'jobspec' : 'application';
      let params = { total: this.totalItems };
      if ( this.totalItems > this.items.length ) {
        params.shown = `${this.showItems.length}/`
      }
      return this.$i18n.tc(`board.${elem}`, this.items.length, params)
    },
    draggables: {
      get() {
        return this.items;
      },
      set(items) {
        for ( var u = 0; u < items.length; u++ ) {
          if ( items[u].status != this.id ) {
            this.setItemStatus(items[u], this.id)
          }
        }
      }
    }
  }
};
</script>

<style>
.card-body > * {
  min-height: 120px;
}
.lane {
 background: linear-gradient(rgba(255,255,255,.2), rgba(255,255,255,0));
 border-radius: 4px;
}
</style>

